﻿Shader "MK/MKGlow/Emission/Diffuse" 
{
	Properties 
	{
		_Color ("Main Color", Color) = (1,1,1,1)
		_MainTex ("Base (RGB)", 2D) = "white" {}
		
		_MKGlowColor ("Glow Color", Color) = (1,1,1,1)
		_MKGlowPower ("Glow Power", Range(0.0,2.5)) = 1.0
		_MKGlowTex ("Glow Texture", 2D) = "black" {}
		_MKGlowTexColor ("Glow Texture Color", Color) = (1,1,1,1)
		_MKGlowTexStrength ("Glow Texture Strength ", Range(0.0,10.0)) = 1.0
		
		
		_Emission ("Emission", Range(0.0,1)) = 1
	}
	SubShader 
	{
		Tags { "RenderType"="MKGlow"}
		LOD 200

		CGPROGRAM
		#pragma surface surf Lambert
		
		sampler2D _MainTex;
		fixed4 _Color;
		half _Emission;

		sampler2D _MKGlowTex;
		half _MKGlowTexStrength;
		fixed4 _MKGlowTexColor;

		struct Input 
		{
			float2 uv_MainTex;
			float2 uv_MKGlowTex;
		};

		void surf (Input IN, inout SurfaceOutput o) 
		{
			fixed4 c = tex2D(_MainTex, IN.uv_MainTex) * _Color;
			fixed4 d = tex2D(_MKGlowTex, IN.uv_MKGlowTex) * _MKGlowTexColor;
			c += (d * _MKGlowTexStrength);
			o.Albedo = c.rgb;
			o.Alpha = c.a;
			o.Emission = d * _Emission * c;
		}
		ENDCG
	}
	Fallback "Diffuse"
}
